%global debug_package %{nil}
%global build_ldflags %{nil}

Name: forgejo
Version: 12.0.0
Release: %autorelease
Summary: Beyond coding, we forge
License: GPL-3.0-or-later
URL: https://codeberg.org/forgejo/forgejo
Source0: %{URL}/releases/download/v%{version}/%{name}-src-%{version}.tar.gz
Source1: forgejo.sysusers

BuildRequires:  coreutils
BuildRequires:  go-rpm-macros
BuildRequires:  golang-bin >= 1.24
BuildRequires:  golang-src >= 1.24
BuildRequires:  make
BuildRequires:  nodejs-npm
BuildRequires:  systemd-rpm-macros

Requires:       git
Requires:       git-lfs
Requires:       sed

%description
Forgejo is a lightweight software forge. Use it to host git repositories,
track their issues and allow people to contribute to them!

%prep
%setup -q -n forgejo-src-%{version}

%build
%global gomodulesmode GO111MODULE=on
%global gotags bindata timetzdata
%global gobuildflags %{?gobuildflags} -tags '%gotags'
	
make %{?_smp_mflags} TAGS="%gotags" generate-go

export GO_LDFLAGS=" \
    -X \"forgejo.org/modules/setting.CustomPath=%{_sysconfdir}/%{name}\" \
    -X \"forgejo.org/modules/setting.CustomConf=%{_sysconfdir}/%{name}/conf/app.ini\" \
    -X \"forgejo.org/modules/setting.AppWorkPath=%{_sharedstatedir}/%{name}\" \
    -X \"main.Tags=%{gotags}\" \
    -X \"main.ReleaseVersion=%{version}-%{release}\" \
    -X \"main.Version=%{version}-%{release}\" \
"

%gobuild -o forgejo %{goipath}

%install
install -m755 -D %{name} %{buildroot}%{_bindir}/%{name}
install -m755 -d %{buildroot}%{_sysconfdir}/%{name}/conf
install -m644 -p -D %{SOURCE1} %{buildroot}%{_sysusersdir}/%{name}.conf

install -m750 -d \
    %{buildroot}%{_sharedstatedir}/%{name} \
    %{buildroot}%{_sharedstatedir}/%{name}/data \
    %{buildroot}%{_sharedstatedir}/%{name}/log

	
%pre
%sysusers_create_compat %{SOURCE1}

%files
%dir %{_sysconfdir}/%{name}
%license LICENSE
%{_bindir}/forgejo
%attr(0750,%{name},%{name}) %dir %{_sharedstatedir}/%{name}
%attr(0750,%{name},%{name}) %dir %{_sharedstatedir}/%{name}/data
%attr(0750,%{name},%{name}) %dir %{_sharedstatedir}/%{name}/log
%{_sysusersdir}/%{name}.conf
